unit frmrtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,StdCtrls,
  blowfish, ExtCtrls, rc6;

type
  TfrmTestRC6 = class(TForm)
    grpText: TGroupBox;
    btnDecrypt: TButton;
    btnEncrypt: TButton;
    edtTestText: TEdit;
    lblTestText: TLabel;
    grpFile: TGroupBox;
    btnFileEncrypt: TButton;
    odlFileEnc: TOpenDialog;
    sdlFileEnc: TSaveDialog;
    btnFileDecrypt: TButton;
    odlFileDec: TOpenDialog;
    sdlFileDec: TSaveDialog;
    rgrMode: TRadioGroup;
    rdbECB: TRadioButton;
    rdbCBC: TRadioButton;
    rdbCFB: TRadioButton;
    rdbOFB: TRadioButton;
    RC61: TRC6;
    grpKeySize: TGroupBox;
    rdb128: TRadioButton;
    rdb192: TRadioButton;
    rdb256: TRadioButton;
    procedure btnFileEncryptClick(Sender: TObject);
    procedure btnEncryptClick(Sender: TObject);
    procedure btnDecryptClick(Sender: TObject);
    procedure btnFileDecryptClick(Sender: TObject);
    procedure rdbECBClick(Sender: TObject);
    procedure rdbCBCClick(Sender: TObject);
    procedure rdbCFBClick(Sender: TObject);
    procedure rdbOFBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rdb128Click(Sender: TObject);
    procedure rdb192Click(Sender: TObject);
    procedure rdb256Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmTestRC6: TfrmTestRC6;

implementation

{$R *.DFM}

procedure TfrmTestRC6.btnFileEncryptClick(Sender: TObject);
begin
     RC61.LoadIVString('Init Vector');
     RC61.InitialiseString('Pass Phrase');
     if odlFileEnc.Execute then
     begin
          if sdlFileEnc.Execute then
          begin
               RC61.EncryptFile(odlFileEnc.FileName, sdlFileEnc.FileName);
          end;
     end;
end;

procedure TfrmTestRC6.btnEncryptClick(Sender: TObject);
var
     Tempstr: string;
begin
     RC61.LoadIVString('Init Vector');
     RC61.InitialiseString('Pass Phrase');
     RC61.EncryptString(edtTestText.Text,Tempstr);
     edtTestText.Text := TempStr;
end;

procedure TfrmTestRC6.btnDecryptClick(Sender: TObject);
var
     Tempstr: string;
begin
     RC61.InitialiseString('Pass Phrase');
     RC61.LoadIVString('Init Vector');
     RC61.DecryptString(edtTestText.Text,Tempstr);
     edtTestText.Text := TempStr;
end;

procedure TfrmTestRC6.btnFileDecryptClick(Sender: TObject);
begin
     RC61.LoadIVString('Init Vector');
     RC61.InitialiseString('Pass Phrase');
     if odlFileDec.Execute then
     begin
          if sdlFileDec.Execute then
          begin
               RC61.DecryptFile(odlFileDec.FileName, sdlFileDec.FileName);
          end;
     end;
end;

procedure TfrmTestRC6.rdbECBClick(Sender: TObject);
begin
     RC61.CipherMode := ECB;
end;

procedure TfrmTestRC6.rdbCBCClick(Sender: TObject);
begin
     RC61.CipherMode := CBC;
end;

procedure TfrmTestRC6.rdbCFBClick(Sender: TObject);
begin
     RC61.CipherMode := CFB;
end;

procedure TfrmTestRC6.rdbOFBClick(Sender: TObject);
begin
     RC61.CipherMode := OFB;
end;

procedure TfrmTestRC6.FormCreate(Sender: TObject);
begin
     RC61.CipherMode := ECB;
     RC61.KeySize := Small128;
end;

procedure TfrmTestRC6.rdb128Click(Sender: TObject);
begin
     RC61.KeySize := Small128;
end;

procedure TfrmTestRC6.rdb192Click(Sender: TObject);
begin
     RC61.KeySize := Med192;
end;

procedure TfrmTestRC6.rdb256Click(Sender: TObject);
begin
     RC61.KeySize := Large256;
end;

end.
